package com.simuwang.manage.task;

import com.simuwang.base.pojo.dos.FundNotMappingInfoDO;
import com.simuwang.base.pojo.dos.FundRegisterDO;
import com.simuwang.manage.service.EmailFundAssetService;
import com.simuwang.manage.service.EmailFundNavService;
import com.simuwang.manage.service.FundAliasService;
import com.simuwang.manage.service.FundNotMappingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Component
public class NotMappingFundComputeTask {

    @Autowired
    private  FundAliasService fundAliasService;

    @Autowired
    private EmailFundNavService emailFundNavService;

    @Autowired
    private EmailFundAssetService emailFundAssetService;

    @Autowired
    private FundNotMappingService fundNotMappingService;

    public void notMappingFundCompute() {
        List<FundRegisterDO> fundRegisterDOList = fundAliasService.getNotMappingFundList();
        List<FundNotMappingInfoDO> fundNotMappingInfoDOList = new ArrayList<>();
        for (FundRegisterDO fundRegisterDO : fundRegisterDOList) {
            FundNotMappingInfoDO fundNotMappingInfoDO = new FundNotMappingInfoDO();
            fundNotMappingInfoDO.setFundName(fundRegisterDO.getFundName());
            fundNotMappingInfoDO.setFundAliasId(fundRegisterDO.getId());
            fundNotMappingInfoDO.setRegisterNumber(fundRegisterDO.getRegisterNumber());
            //异常净值数量
            Integer navTotal = emailFundNavService.countNoStoreNav(fundRegisterDO.getFundName(),fundRegisterDO.getRegisterNumber());
            //异常净值数量
            Integer assetTotal = emailFundAssetService.countNoStoreAsset(fundRegisterDO.getFundName(),fundRegisterDO.getRegisterNumber());

            String lastPriceDate = emailFundNavService.getLastPriceDateByfundRegisterNumber(fundRegisterDO.getFundName(),fundRegisterDO.getRegisterNumber());
            fundNotMappingInfoDO.setAssetTotal(assetTotal);
            fundNotMappingInfoDO.setLastPriceDate(lastPriceDate);
            fundNotMappingInfoDO.setNavTotal(navTotal);
            fundNotMappingInfoDO.setIsvalid(1);
            fundNotMappingInfoDO.setCreateTime(new Date());
            fundNotMappingInfoDO.setUpdateTime(new Date());
            fundNotMappingInfoDOList.add(fundNotMappingInfoDO);
        }
        fundNotMappingService.batchInsert(fundNotMappingInfoDOList);
    }
}
